SystemOrganization addCategory: #'Stripe-Seaside'!

!String methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 10/25/2011 20:31'!
asFunction: aCollection named: aNameString
	^ (JSStream on: self) asFunction: aCollection named: aNameString! !

!WATextInputTag methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 10/25/2011 20:30'!
noAutocomplete 
	self attributes at: 'autocomplete'put: 'off'! !

!Object methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 10/25/2011 20:31'!
asFunction: aCollection named: aNameString
	^ JSFunction new add: self; arguments: aCollection; functionName: aNameString! !

WAComponent subclass: #StripeCreditCardForm
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stripe-Seaside'!

!StripeCreditCardForm commentStamp: 'PaulDeBruicker 10/21/2011 14:45' prior: 0!
You need to put your publishable key in the YOUR_PUBLISHABLE_KEY spot in the renderContentOn: method!

!StripeCreditCardForm classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/21/2011 15:17'!
canBeRoot
	^ true! !

!StripeCreditCardForm classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 12:30'!
createFunctionNameInJSFunction
	(JSFunction instVarNames includes: 'functionName')
		ifFalse: [ JSFunction addInstVarNamed: 'functionNamed' ]! !

!StripeCreditCardForm classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/4/2012 12:30'!
initialize
	"
StripeCreditCardForm initialize
"

	| app |
	app := WAAdmin register: self asApplicationAt: 'stripe'.
	(app filters detect: #isExceptionFilter) configuration at: #exceptionHandler put: WADebugErrorHandler.
	self createFunctionNameInJSFunction! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
addTokenToForm
	^ 'var pmtForm = $("#payment-form");
        var token = response["id"];
        $("#' , self tokenDiv
		,
			'").val(token);
        pmtForm.get(0).submit();}'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
addressOneDiv
	^ 'addr-one'! !

!StripeCreditCardForm methodsFor: 'charge-details' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
amount
	"amount in cents.  so $1.00 = 100"

	^ 100! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
cardNumberDiv
	^ 'card-number'! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
chargeCustomerFor: aStripeToken
	| cust charge |
	cust := StripeCustomer newFromToken: aStripeToken.
	charge := StripeCharge newChargeFor: self amount toCustomer: cust! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
createStripeTokenForSimpleForm
	^ self disableSubmitButton , self setAmount , self createToken , self stopReturn
		asFunction: #('event')
		named: 'createStripeToken'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
createToken
	^ JSStream on: 'Stripe.createToken(' , self createTokenData , ', amount , ' , self responseHandlerFunctionName , ')'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 12/16/2011 13:09'!
createTokenData
	^ '{name : $("#' , self nameDiv , '").val(), number : $("#' , self cardNumberDiv , '").val(),cvc : $("#' , self cvcDiv
		, '").val() , exp_month : $("#' , self monthDiv , '").val(), exp_year : $("#' , self yearDiv
		, '").val(), address_line1 : $("#' , self addressOneDiv , '").val(), address_zip : $("#' , self zipDiv , '").val()}'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
cvcDiv
	^ 'card-cvc'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
disableSubmitButton
	^ JSStream on: '$("#' , self formDiv , ' .submit").attr("disabled","disabled")'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
errorDiv
	^ 'card-error'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
errorNotification
	^ ' 
	if (response.error) {
	$("#payment-form .submit").removeAttr("disabled");
	if ((response.param == "exp_year")||(response.param == "exp_month")) {
	 $("#' , self errorDiv
		,
			'").html("The expiration date is incorrect");
	} else {
        $("#' , self errorDiv
		,
			'").html(response.error.message);
	}
    } else {'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
formDiv
	^ 'payment-form'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
monthDiv
	^ 'card-month-expiry'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 12/16/2011 13:08'!
nameDiv
	^ 'cc-name'! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 11:11'!
renderAddressRow: html
	html div
		class: 'form-row';
		with: [ 
					html label
						for: self addressOneDiv;
						with: 'Billing Street Address:'.
					html break.
					html textInput
						name: nil;
						id: self addressOneDiv;
						size: 20.
					html break.
					html label
						for: self addressOneDiv;
						with: 'Zip Code:'.
					html break.
					html textInput
						name: nil;
						id: self zipDiv;
						size: 6 ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 12:00'!
renderCVCRow: html
	html div
		class: 'form-row';
		with: [ 
					html label
						for: self cvcDiv;
						with: 'CVV:'.
					html break.
					html textInput
						name: nil;
						id: self cvcDiv;
						size: 4;
						noAutocomplete.
					self renderWhatIsMyCVV: html ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
renderCardNumberRow: html
	html div
		class: 'form-row';
		with: [ 
					html label
						for: self cardNumberDiv;
						with: 'Card Number:'.
					html break.
					html textInput
						name: nil;
						id: self cardNumberDiv;
						size: 20;
						noAutocomplete ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 10:24'!
renderChargeButton: html
	html submitButton
		onClick:
				(html jQuery
						script: [ :s | 
							s << self createStripeTokenForSimpleForm.
							s << (JSStream on: 'createStripeToken()') ]);
		with: 'Submit Payment'! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 10:47'!
renderContentOn: html
	html script: self setPublishableKey.
	self renderForm: html.
	self renderStripeResponseHandler: html! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
renderExpirationRow: html
	html div
		class: 'form-row';
		with: [ 
					html label
						for: self monthDiv;
						with: 'Expiration (MM/YYYY):'.
					html break.
					html textInput
						name: nil;
						id: self monthDiv;
						size: 2.
					html span: ' / '.
					html textInput
						name: nil;
						size: 4;
						id: self yearDiv ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 13:07'!
renderForm: html
	html form
		method: 'post';
		id: self formDiv;
		with: [ 
					self renderValidationErrorOn: html.
					self renderNameRow: html.
					self renderCardNumberRow: html.
					self renderCVCRow: html.
					self renderExpirationRow: html.
					self renderAddressRow: html.
					self renderTokenHiddenInput: html.
					self renderChargeButton: html ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 13:06'!
renderNameRow: html
	html div
		class: 'form-row';
		with: [ 
					html label
						for: self nameDiv;
						with: 'Name On Card:'.
					html break.
					html textInput
						name: nil;
						id: self nameDiv;
						size: 20;
						noAutocomplete ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
renderStripeResponseHandler: html
	html
		script:
			((JSStream on: self stripeResponseHandler) asFunction: #('status' 'response') named: self responseHandlerFunctionName)! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
renderTokenHiddenInput: html
	html hiddenInput
		id: self tokenDiv;
		callback: [ :val | 
					val = ''
						ifFalse: [ self chargeCustomerFor: val ] ]! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
renderValidationErrorOn: html
	html div
		id: self errorDiv;
		style: 'color:#FF0000'! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 12:02'!
renderWhatIsMyCVV: html
	html anchor
		style: 'font-size:11px';
		url: 'http://www.cvvnumber.com/cvv.html';
		target: '_blank';
		with: 'What is my CVV code?'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
responseHandlerFunctionName
	^ 'stripeResponseHandler'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
setAmount
	^ JSStream on: 'var amount = ' , self amount greaseString! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
setPublishableKey
	^ JSStream on: 'Stripe.setPublishableKey("' , StripeObject publishableApiKey , '")'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
stopReturn
	^ JSStream on: 'return false'! !

!StripeCreditCardForm methodsFor: 'javascript' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
stripeResponseHandler
	^ self errorNotification , self addTokenToForm! !

!StripeCreditCardForm methodsFor: 'keys' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
stripeTestAPIKey
	^ 'pk_WLpX9yZ4Rq6C3qFq0tlsXJnnE3GQ8'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
tokenDiv
	^ 'cc-token'! !

!StripeCreditCardForm methodsFor: 'rendering' stamp: 'PaulDeBruicker 12/16/2011 12:26'!
updateRoot: htmlRoot
	super updateRoot: htmlRoot.
	htmlRoot javascript url: 'http://code.jquery.com/jquery-1.6.4.min.js'.
	htmlRoot javascript url: 'https://js.stripe.com/v1/'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
yearDiv
	^ 'card-year-expiry'! !

!StripeCreditCardForm methodsFor: 'divIDs' stamp: 'PaulDeBruicker 6/1/2012 17:07'!
zipDiv
	^ 'zipcode'! !

!JSFunction methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 10/25/2011 20:31'!
asFunction: aCollection named: aNameString
	
	self arguments: aCollection;
		functionName: aNameString! !

!JSFunction methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 12/16/2011 16:37'!
functionName
	^ functionNamed isNil
		ifTrue: [ 'function (' ]
		ifFalse: [ 'function ' , functionNamed , '(' ]! !

!JSFunction methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 12/14/2011 16:13'!
functionName: aNameString
	functionNamed := aNameString! !

!JSFunction methodsFor: '*stripe-seaside' stamp: 'PaulDeBruicker 10/25/2011 20:33'!
javascriptContentOn: aStream
	aStream nextPutAll: self functionName.
	self arguments do: [ :each | aStream nextPutAll: each ] separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse:
			[ statements allButLast do:
					[ :each | 
					aStream
						javascript: each;
						nextPut: $; ].
			self return ifTrue: [ aStream nextPutAll: 'return ' ].
			aStream javascript: statements last ].
	aStream nextPut: $}! !
StripeCreditCardForm initialize!
